package sun.net.www;

import java.util.StringTokenizer;
import java.security.AccessController;
import sun.security.action.GetPropertyAction;
import java.io.File;
import java.io.IOException;
import java.io.FileOutputStream;
import java.net.URL;
import java.io.InputStream;
import java.net.URLConnection;

class MimeLauncher extends Thread
{
    URLConnection uc;
    MimeEntry m;
    String genericTempFileTemplate;
    InputStream is;
    String execPath;
    
    MimeLauncher(MimeEntry m, URLConnection uc, InputStream is, String genericTempFileTemplate, String name) throws ApplicationLaunchException {
        super(name);
        this.m = m;
        this.uc = uc;
        this.is = is;
        this.genericTempFileTemplate = genericTempFileTemplate;
        String launchString = this.m.getLaunchString();
        if (!this.findExecutablePath(launchString)) {
            int index = launchString.indexOf(32);
            String substring;
            if (index != -1) {
                substring = launchString.substring(0, index);
            }
            else {
                substring = launchString;
            }
            throw new ApplicationLaunchException(substring);
        }
        else {
            return;
        }
    }
    
    protected String getTempFileName(URL url, String s) {
        int lastIndex = s.lastIndexOf("%s");
        String str = s.substring(0, lastIndex);
        String substring = "";
        if (lastIndex < s.length() - 2) {
            substring = s.substring(lastIndex + 2);
        }
        long n;
        int index;
        for (n = System.currentTimeMillis() / 1000L; (index = str.indexOf("%s")) >= 0; str = str.substring(0, index) + n + str.substring(index + 2)) {}
        String file = url.getFile();
        String substring2 = "";
        int lastIndex2 = file.lastIndexOf(46);
        if (lastIndex2 >= 0 && lastIndex2 > file.lastIndexOf(47)) {
            substring2 = file.substring(lastIndex2);
        }
        return str + ("HJ" + url.hashCode()) + n + substring2 + substring;
    }
    
    @Override
    public void run() {
        try {
            String s = this.m.getTempFileTemplate();
            if (s == null) {
                s = this.genericTempFileTemplate;
            }
            String tempFileName = this.getTempFileName(this.uc.getURL(), s);
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(tempFileName);
                byte[] array = new byte[2048];
                try {
                    int read;
                    while ((read = this.is.read(array)) >= 0) {
                        fileOutputStream.write(array, 0, read);
                    }
                }
                catch (IOException ex) {}
                finally {
                    fileOutputStream.close();
                    this.is.close();
                }
            }
            catch (IOException ex2) {}
            String s2;
            int index;
            for (s2 = this.execPath; (index = s2.indexOf("%t")) >= 0; s2 = s2.substring(0, index) + this.uc.getContentType() + s2.substring(index + 2)) {}
            boolean n = false;
            int index2;
            while ((index2 = s2.indexOf("%s")) >= 0) {
                s2 = s2.substring(0, index2) + tempFileName + s2.substring(index2 + 2);
                n = true;
            }
            if (n == 0) {
                s2 = s2 + " <" + tempFileName;
            }
            Runtime.getRuntime().exec(s2);
        }
        catch (IOException ex3) {}
    }
    
    private boolean findExecutablePath(String s) {
        if (s == null || s.length() == 0) {
            return false;
        }
        int index = s.indexOf(32);
        String substring;
        if (index != -1) {
            substring = s.substring(0, index);
        }
        else {
            substring = s;
        }
        if (new File(substring).isFile()) {
            this.execPath = s;
            return true;
        }
        String str = (String)AccessController.doPrivileged(new GetPropertyAction("exec.path"));
        if (str == null) {
            return false;
        }
        StringTokenizer o = new StringTokenizer(str, "|");
        while (o.hasMoreElements()) {
            String s2 = (String)o.nextElement();
            if (new File(s2 + File.separator + substring).isFile()) {
                this.execPath = s2 + File.separator + s;
                return true;
            }
            continue;
        }
        return false;
    }
}
